stages:
  - test
  - build

format:
  image: golang:latest
  stage: test
  before_script:
    - go mod download
  script:
    - gofmt -e -s -w .
    - go vet $(go list ./...)
  only:
    - main
    - merge_requests

test:
  image: shanduur/ddgo:latest
  stage: test
  script:
    - ls /root/go/bin
  variables:
    GIT_REPO: https://gitlab.com/sat-polsl/gcs/gcs-core.git
    ADDITIONAL_DEPS: "gcc musl-dev"
    TEST_ARGS: "-cover -race"
    TEST_EMAIL_ADDRESS: "mail@example.com"
    TEST_SMTP_HOST: "smtp.mailtrap.io"
    TEST_SMTP_PORT: "465"
    TEST_SMTP_SECURE: "false"
    TEST_ALLOWED_DOMAINS: "example.com"
  only:
    - main
    - merge_requests

build:
  stage: build
  image: ezkrg/buildx:latest
  rules:
    - if: $CI_COMMIT_TAG
  variables:
    IMAGE_TAG_LATEST: ${CI_REGISTRY_IMAGE}:latest
    IMAGE_TAG: ${CI_REGISTRY_IMAGE}:${CI_COMMIT_TAG}
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker buildx create --use --name ci-run
    - docker buildx build --platform linux/amd64,linux/arm64 --output=type=registry -t ${IMAGE_TAG_LATEST} -t ${IMAGE_TAG} .
    - docker buildx rm ci-run
  services:
    - docker:dind
